#include <stdio.h>

struct Sighting {
  double locX, locY;
  int valid;
};

struct Unit {
  char uname[40];
  struct Sighting *seen;  // array of units entries
  int last_day_seen;
};

char buffer[128];

char directory[128];

int units;
int days;

double Xa, Xb;
double Ya, Yb;

void read_rest() {
  gets(buffer);
};

struct Unit *unit_table;

void produce_path( FILE *f, int cur_day, int cur_unit )
{
   int last;
   fprintf(f, "<");

   last = unit_table[cur_unit].last_day_seen;
   if (last != 0) {
     fprintf( f, "%d %d, ", (int) unit_table[cur_unit].seen[last].locX,
                            (int) unit_table[cur_unit].seen[last].locY );
   }

   fprintf(f, "%d %d>\n", (int) unit_table[cur_unit].seen[cur_day].locX,
                          (int) unit_table[cur_unit].seen[cur_day].locY );
   unit_table[cur_unit].last_day_seen = cur_day;
}

void produce_data()
{
   int cur_id = 0;
   int cur_TS = 100;
   int cur_day, cur_unit;
   FILE *f;
   for (cur_day = 1; cur_day <= days; cur_day++) {
     sprintf( buffer, "%sday%d", directory, cur_day );
     f = fopen (buffer, "w+");
     for (cur_unit = 0; cur_unit < units; cur_unit++) {
         if (unit_table[cur_unit].seen[cur_day].valid ) {
             //fprintf(f, "%d \n", cur_TS );
             fprintf(f, "\"NOW\"\n");
             fprintf(f, "%d\n", cur_id ); cur_id++;
             fprintf(f, "\"%s%sday%d\"\n", directory, 
                                           unit_table[cur_unit].uname,
                                           cur_day );
	     // start position
	     int last = unit_table[cur_unit].last_day_seen;
	     if (last != 0) {
	       fprintf( f, "<%d %d>\n", 
			(int) unit_table[cur_unit].seen[last].locX,
			(int) unit_table[cur_unit].seen[last].locY );
	     } else {
	       fprintf(f, "< %d %d >\n", 
		       (int) unit_table[cur_unit].seen[cur_day].locX,
		       (int) unit_table[cur_unit].seen[cur_day].locY );
	     }

	     // end position
             fprintf(f, "< %d %d >\n", 
                        (int) unit_table[cur_unit].seen[cur_day].locX,
                        (int) unit_table[cur_unit].seen[cur_day].locY );
             produce_path( f, cur_day, cur_unit );
             fprintf(f, " 100 \n\n"); // numTroops
         } 
     }
     cur_TS += 100;
     fclose(f);
   }
}

void read_globals() {
  scanf("%s", directory); read_rest();
  scanf("%d", &units ); read_rest();
  scanf("%d", &days ); read_rest();
  scanf("%lf %lf", &Xa, &Xb); read_rest();
  scanf("%lf %lf", &Ya, &Yb); read_rest();

  printf("directory: >%s<\n", directory);
  printf(" %d units, %d days\n", units, days);
  printf(" X transform: %lf %lf\n", Xa, Xb );
  printf(" Y transform: %lf %lf\n", Ya, Yb );
}

void print_sightings() {
   int i, j;
   for (i = 0; i < units; i++) {
     printf("%s\n", unit_table[i].uname);

     for (j = 0; j <= days; j++) {
        if (unit_table[i].seen[j].valid) {
           printf("%d %lf %lf\n", j, unit_table[i].seen[j].locX, 
                                     unit_table[i].seen[j].locY );
        }
     }
   }
}
        


main()
{
   int i, j;
   int nr_sightings;
   double x, y;
   int this_day;

   read_globals();

   unit_table = (struct Unit *) malloc(units * sizeof(struct Unit));

   // read in everything
   for (i = 0; i < units; i++) {
     unit_table[i].last_day_seen = 0;
     unit_table[i].seen = (struct Sighting *) malloc( (days+1) * 
                                                      sizeof(struct Sighting));
     for (j = 0 ; j <= days; j++) {
       unit_table[i].seen[j].valid = 0;
     }

     scanf("%s", unit_table[i].uname ); 
     scanf("%d", &nr_sightings);

     for (j = 0; j < nr_sightings; j++) {
       scanf("%d %lf %lf", &this_day, &x, &y );
       unit_table[i].seen[this_day].locX = Xa*x + Xb;
       unit_table[i].seen[this_day].locY = Ya*y + Yb;
       unit_table[i].seen[this_day].valid = 1;
     }
   }

   produce_data();

}
