/*<std-header incl-file-exclusion=ERRORMAP_H>

           Copyright 1998, NCR Corporation.  All Rights Reserved.

                               NCR Confidential.


 $Id: ErrorMap.h,v 1.7 1998/05/19 03:25:37 kupsch Exp $


*/

#ifndef ERRORMAP_H
#define ERRORMAP_H


/*  -- do not edit anything above this line --   </std-header>*/

#include <iostream.h>
//
// This file defines a template for an error map.  An error map
// is used to store an ordered domain of error messages.  Each element
// in the error domain has a non-zero error code, and a string.
// string and code parts of elements of the domain are accessed 
// via a n enumeration.
// Checked access is also provided via integer.
//

class ErrDesc {
public:
	int code;
	char SQLStateClass[3];
	char SQLStateSubClass[4];
	const char *message;
};

template <class T, int max>
class ErrorMap {
	static ErrDesc m[];
public:
	const ErrDesc &operator[](T x) {
		return m[x];
	};
	const ErrDesc &operator[](int i) {
		if (i >=0 && i <= max)
			return m[i];
		else {
			cout << "Error code " << i << " is out of range 0 - " << max << endl;
			return m[max];
		};
	};
	T GetEnumForCode(int code) {
		int i;
		for (i = 0; i < max; i ++) {
			if (m[i].code == code) {
				return (T) i;
			}
		}
		return (T) max;
	};
};

/*<std-footer incl-file-exclusion=ERRORMAP_H>  -- do not edit anything below this line -- */

#endif          /*</std-footer>*/
