/*<std-header incl-file-exclusion=ARGLIST_H>

           Copyright 1998, NCR Corporation.  All Rights Reserved.

                               NCR Confidential.


 $Id: argList.h,v 1.4 1998/05/19 03:34:31 kupsch Exp $


*/

#ifndef ARGLIST_H
#define ARGLIST_H


/*  -- do not edit anything above this line --   </std-header>*/

#include <string.h>
#include <stringType.h>

//
// ArgList class
// This class parses and manages command line arguments.
//
class ArgList {
	enum {MAX_ARGS = 20};	// should make this more flexible.
	const char *delim;
	int argc;
	String *argv;
	int first;
	String Empty;
public:
	ArgList(const char *cline, const char *_delim = " \t\n");
	~ArgList();
	 String &operator[](int i) {
		int idx = first + i;
		if (idx < argc && idx >= 0)
			return argv[idx];
		else
			return Empty;
	};
	String &Shift();
	void Unshift();
	int GetArgc() {
		return argc;
	};
};

//
// ArgList functions
//
	
inline ArgList::~ArgList() {
	delete[] argv;
}

inline ArgList::ArgList(const char *cline, const char *_delim) {

	char *line = new char [strlen(cline) + 1];
	strcpy(line, cline);

	delim = _delim;
	argv = new String[MAX_ARGS];

	const char *p = strtok(line, delim);
	for (argc=0; p != 0 && argc < MAX_ARGS; argc++) {
		argv[argc] = p;
		p = strtok(0, delim);
	}
	delete[] line;
	first = 0;
}

inline void ArgList::Unshift() {
	if (first > 0)
		first--;
}

inline String &ArgList::Shift() {
	if (first >= argc)
		return Empty;
	return argv[first++];
}

/*<std-footer incl-file-exclusion=ARGLIST_H>  -- do not edit anything below this line -- */

#endif          /*</std-footer>*/
