/*<std-header incl-file-exclusion=CLMACROS_H>

           Copyright 1998, NCR Corporation.  All Rights Reserved.

                               NCR Confidential.


 $Id: clMacros.h,v 1.14 1998/05/19 03:24:58 kupsch Exp $


*/

#ifndef CLMACROS_H
#define CLMACROS_H


/*  -- do not edit anything above this line --   </std-header>*/

///////////////////////////////////////////////////////////////////////////
//
// clMacros.h : Some useful macros for the client.
//
///////////////////////////////////////////////////////////////////////////

// Fix for the Sparcs
#ifndef SEEK_SET
#define SEEK_SET 0
#endif
#include <paraError.h>

// No error message needed for clEND_TUPLES is a message not an error

#define CL_CALL(x){ \
        int _err = (x);\
	if (_err != clNOERROR)  { \
	  return clSaveError(_err, __FILE__, __LINE__); \
        } \
}

#define INT_CL_CALL(x){\
		       int _err = (x);\
		       if (_err != clNOERROR && _err != clEND_TUPLES)\
			 {\
			    return clSaveError(_err, __FILE__, __LINE__);\
			 }\
			if(_err == clEND_TUPLES)\
			  return clEND_TUPLES;\
                       }

#define CL_OPEN_CSR_CALL(x){\
		       int _err = (x);\
		       if (_err != clNOERROR && _err != clEND_TUPLES)\
			 {\
			    return clSaveError(_err, __FILE__, __LINE__);\
			 }\
                       }

// Changed to call SetServerResponse to call if s is null -
// must handle null response since this is what we get if server
// crashes - this fix prevents client from core dumping on server core
// dump - Kristin Tufte 3-5-97
// added the connection conn as another parameter...
// for transactions using cursors -- karthik 03/15/97  

#define KR_PROC_RES(conn,s)   {       \
		if ((s && s->IsError()) || !s) { \
                        if ( (conn)->GetXactMgr() ) (conn)->GetXactMgr()->abort() ; \
			BaseErrorManager::MyErrorManager()->SetServerResponse(s);\
			delete s; \
			ServerError se; \
			se << ELOC; \
            return se ; \
		}\
}     

#if 0
#define KR_PROC_RES(s)   {       \
        if ( s && s->IsError() ) {              \
                char*   errStr = ((KR_ErrorMsg_t *)s)->GetErrorMsg() ; \
                cerr << "Server error detected at " << __FILE__ << ":" \
                     << __LINE__ \
                     << " :" << endl << errStr << endl; \
                delete [] errStr ; \
                delete s ;         \
                return clSERVER_ERR ; \
        }                       \
        else if ( !s )  {       \
                cerr << "Server error detected at " << __FILE__ << ":" \
                     << __LINE__ \
                     << " : No Error Message Available " << endl; \
                return clSERVER_ERR;               \
        }                       \
}     
#endif

/*<std-footer incl-file-exclusion=CLMACROS_H>  -- do not edit anything below this line -- */

#endif          /*</std-footer>*/
