/*<std-header incl-file-exclusion=CLIENTCLOSEDPOLYGONADT_H>

           Copyright 1998, NCR Corporation.  All Rights Reserved.

                               NCR Confidential.


 $Id: clientClosedPolygonAdt.h,v 1.7 1998/05/19 03:25:10 kupsch Exp $


*/

#ifndef CLIENTCLOSEDPOLYGONADT_H
#define CLIENTCLOSEDPOLYGONADT_H


/*  -- do not edit anything above this line --   </std-header>*/

#include <clientBaseAdt.h>
#include <clientRealAdt.h>
#include <clientInt4Adt.h>

class ClientPolyLineAdt; 
class ClientRectangleAdt; 

///////////////////////////////////////////////////////////////////////////
//
// ClosedPolygonAdt.h : The ClosedPolygon Adt represented as a (variable)
//                      number of points.
//
///////////////////////////////////////////////////////////////////////////
class ClientClosedPolygonAdt : public ClientBaseAdt
{
   friend class ClientSwCheesePolyAdt ;

   public:
   
      // Constructor.
      ClientClosedPolygonAdt();

	// all the functions that are accessable by user
	// you can find equivalent functions in the internal
	// ADT implementation: closedPolygonAdt class.
      virtual int shift(const ClientBaseAdt& xshift, 
			const ClientBaseAdt& yshift,
			ClientClosedPolygonAdt& shPoly) const;
      
      virtual int area(ClientRealAdt& sz) const;
      virtual int box(ClientRectangleAdt& bBox) const;
      virtual int height(ClientInt4Adt& sz) const;
      virtual int width(ClientInt4Adt& sz) const;
      virtual int addPoint(int x, int y);
      virtual int joinLine(const ClientPolyLineAdt& line);
};

/*<std-footer incl-file-exclusion=CLIENTCLOSEDPOLYGONADT_H>  -- do not edit anything below this line -- */

#endif          /*</std-footer>*/
