/*<std-header incl-file-exclusion=CLIENTONEDARRAYADT_H>

           Copyright 1998, NCR Corporation.  All Rights Reserved.

                               NCR Confidential.


 $Id: clientOneDArrayAdt.h,v 1.7 1998/05/19 03:25:15 kupsch Exp $


*/

#ifndef CLIENTONEDARRAYADT_H
#define CLIENTONEDARRAYADT_H


/*  -- do not edit anything above this line --   </std-header>*/

///////////////////////////////////////////////////////////////////////////
//
// 1dArrayAdt.h : A one-dimensional array interface derived from the
//                n-dimensional array adt.
//
///////////////////////////////////////////////////////////////////////////

#include <clientNArrayAdt.h>

template <class T>
class ClientOneDArrayAdt : public ClientNArrayAdt<T>
{
public:
  ClientOneDArrayAdt();

  // One-dimensional array interface
  unsigned int dim() const;
 
  // gets/sets the value at index idx. data is input/output value
  int getVal(unsigned int idx, T& data); // would be nice if this were  const
  int setVal(unsigned int idx, T  data);

  // copy out interface to read a sub-array.  Parameters are start
  // index, number of values to read, a pointer to space for the
  // result (must already be allocated) and the stride.  A stride of 
  // 1 means read every element, a stride of 2 means read every other
  // element.  stride defaults to 1
  int readSubArray(unsigned int start, 
		   unsigned int numValues, 
		   void* data, 
		   unsigned int stride);     

  // identical to readSubArray except, that the data provided
  // is written into the array
  int writeSubArray(unsigned int start, 
		    unsigned int numValues, 
		    void* data, 
		    unsigned int stride);
};

typedef  ClientOneDArrayAdt<s32bit>   ClientInt4OneDArray;
typedef  ClientOneDArrayAdt<char>     ClientCharOneDArray;

/*<std-footer incl-file-exclusion=CLIENTONEDARRAYADT_H>  -- do not edit anything below this line -- */

#endif          /*</std-footer>*/
