/*<std-header incl-file-exclusion=CLIENTRASTERARRADT_H>

           Copyright 1998, NCR Corporation.  All Rights Reserved.

                               NCR Confidential.


 $Id: clientRasterArrAdt.h,v 1.6 1998/05/19 03:25:18 kupsch Exp $


*/

#ifndef CLIENTRASTERARRADT_H
#define CLIENTRASTERARRADT_H


/*  -- do not edit anything above this line --   </std-header>*/

///////////////////////////////////////////////////////////////////////////
//
// ClientRasterArrAdt.h : The wrapper for Raster Adt derived from array adt.
//
///////////////////////////////////////////////////////////////////////////

#include <clientNArrayAdt.h>
#include <clientRealAdt.h>

template <class T>
class ClientRasterArrAdt : public ClientNArrayAdt<T>
{
public:
  ClientRasterArrAdt();

  virtual int clClip(const ClientBaseAdt* clip_shape, 
		     ClientBaseArrayAdt& result);
  int average(ClientRealAdt& result);
  
  int lower_res(const ClientBaseAdt* res, 
		ClientBaseArrayAdt& result);

  int getDispChunk(unsigned int chunkNum, 
		   ParaRectangle& tileBB,
		   u_short& numXcells,
		   u_short& numYcells,
		   void*& data, 
		   unsigned int& size);

  unsigned int x_cells();
  unsigned int y_cells();

  // Corner is size of whole edge integer divided by
  // length of each cell
  // Remember x is mapped to dimension 1 in the array
  // but dimension 0 in the bounding box
  unsigned int xCellLen();
  unsigned int yCellLen();
};

/*<std-footer incl-file-exclusion=CLIENTRASTERARRADT_H>  -- do not edit anything below this line -- */

#endif          /*</std-footer>*/
