/*<std-header incl-file-exclusion=PARAASSERT_H>

           Copyright 1998, NCR Corporation.  All Rights Reserved.

                               NCR Confidential.


 $Id: paraAssert.h,v 1.14 1998/12/07 15:26:06 jiebing Exp $


*/

#ifndef PARAASSERT_H
#define PARAASSERT_H


/*  -- do not edit anything above this line --   </std-header>*/

///////////////////////////////////////////////////////////////////////////
//
// paraAssert.h : Assertion cheak.
//
///////////////////////////////////////////////////////////////////////////

#include <stdlib.h>
#include <stdio.h>

// Contact Navin if you have trouble with this...
extern void printError (const char *prefix = NULL);

#ifdef PARA_DEBUG
#define para_assert(x) do { \
		         if ((x) == 0) \
			 { \
			   cerr << "para assertion failed in \"" \
		                << __FILE__ << " " \
				<< __LINE__ << "\"" << endl; \
                           printError (); \
			   abort(); \
			 } \
                       } while (0)

#define PARA_DEBUG_ONLY(x) x
#else 
#define para_assert(x) /**/
#define PARA_DEBUG_ONLY(x) /**/
#endif

// Check for a condition
#define para_check(x) do { \
		         if (!(x)) \
			 { \
			   cerr << "TOR checking failed in \"" \
		                << __FILE__ << " " \
				<< __LINE__ << "\"" << endl; \
                           printError (); \
			   abort(); \
			 } \
                       } while (0)

/*<std-footer incl-file-exclusion=PARAASSERT_H>  -- do not edit anything below this line -- */

#endif          /*</std-footer>*/
