/*<std-header incl-file-exclusion=PARAERRORSTATUS_H>

           Copyright 1998, NCR Corporation.  All Rights Reserved.

                               NCR Confidential.


 $Id: paraErrorStatus.h,v 1.8 1998/11/11 13:29:58 kupsch Exp $


*/

#ifndef PARAERRORSTATUS_H
#define PARAERRORSTATUS_H


/*  -- do not edit anything above this line --   </std-header>*/

#include <iostream.h>

class ClientErrorManager;
class CurrentCursor;
class CurrentErrorManager;

class ParaErrorStatus {

     friend class CurrentCursor;

public:

     enum ErrorMode {
		eSimple,
		eSimpleWithExplanation,
		eDetailed
     };

     ParaErrorStatus(ErrorMode emode = eDetailed);
     ~ParaErrorStatus();

    bool IsError();
    void Clear();
    ErrorMode SetDetailedMode(ErrorMode);

	const char *GetDefaultErrorString();
    void GetDefaultErrorString(ostream &);
    void GetExtendedErrorString(ostream &);
    void GetSimpleErrorString(ostream &);
    void GetErrorExplanationString(ostream &);

    int GetServerErrorCode();
	const char *GetSqlClass();
	const char *GetSqlSubclass();

    void UseAsDefault(bool flag = true);

    // Call this to register this error status as default 
    // for reporting error status.

private:
	const char *GetExtendedErrorString();
	const char *GetSimpleErrorString();
	const char *GetErrorExplanationString();

	char *errorString;
	int errorStringSize;
    ClientErrorManager *em;
    ErrorMode errorMode;
    CurrentErrorManager *currentEm;
};

/*<std-footer incl-file-exclusion=PARAERRORSTATUS_H>  -- do not edit anything below this line -- */

#endif          /*</std-footer>*/
