/*<std-header incl-file-exclusion=STRINGTYPE_H>

           Copyright 1998, NCR Corporation.  All Rights Reserved.

                               NCR Confidential.


 $Id: stringType.h,v 1.12 1998/12/04 22:54:31 kupsch Exp $


*/

#ifndef STRINGTYPE_H
#define STRINGTYPE_H


/*  -- do not edit anything above this line --   </std-header>*/

#include <string.h>

#include <ctype.h>

///////////////////////////////////////////////////////////////////////////
//
// stringType.h : The string class.
//
///////////////////////////////////////////////////////////////////////////

// A new String class.
class String {
   friend inline bool operator==(const String&, const String&);
   friend inline bool operator==(const String&, const char*);
   friend unsigned int hash (const String&);

public:
	String(const char* _name = "") :
		name(0)  {
		set(_name);
	};

	String(const String &X) {
		set(X.name);
	};

	virtual ~String() {
		delete[] name;
	};

	operator const char *() {
		return name;
	}

	String &operator=(const char *X) {
		set(X);
		return *this;
	};

	String &operator=(const String &X) {
		set(X.name);
		return *this;
	};

	String &operator<<(const char *X) {
		char *tmp = new char[Length() + strlen(X) + 1];
		strcpy(tmp, name);
		strcat(tmp, X);
		delete[] name;
		name = tmp;
		return *this;
	};

	int Length() {
		if (name)
			return(strlen(name));
		else
			return 0;
	};

	char *Dup() {
		char *tmp = new char[Length() + 1];
		strcpy(tmp, name);
		return tmp;
	};

	String &ToUpper() {
		char *n = name;
		while (n && *n) {
			*n = toupper(*n);
			n++;
		}
		return *this;
	}


protected:
	char* name;

	virtual void set(const char* _name) {
		delete[] name;
		name = 0;
		if (_name) {
			name = new char[strlen(_name)+1];
	 		strcpy(name, _name);
		} else {
			name = new char[1];
			name[0] = '\0';
		}
	};



};

inline bool operator==(const String& str1, const String& str2) 
{
   return !strcmp(str1.name, str2.name);
}

inline bool operator==(const String& str1, const char* str2) 
{
   return !strcmp(str1.name, str2);
}

inline bool operator!=(const String& str1, const String& str2) 
{
   return !(str1 == str2);
}

inline bool operator!=(const String& str1, const char* str2) 
{
   return !(str1 == str2);
}

/*<std-footer incl-file-exclusion=STRINGTYPE_H>  -- do not edit anything below this line -- */

#endif          /*</std-footer>*/
