# <std-header style=TCL orig-src=PTK>
#
#            Copyright 1998, NCR Corporation.  All Rights Reserved.
#
#                                NCR Confidential.
#
#
#  $Id: Argv.tcl,v 1.3 1998/05/19 03:22:39 kupsch Exp $
#
#  This file was originally part of ptk, a front end based on TCL/TK to the
#  Paradise database system developed by the University of Wisconsin-Madison.
#  The above copyright applies to changes made to this file by NCR Corporation.
#  The original copyright which may appear in the source below applies to the
#  original file as obtained by NCR Corporation and unchanged parts of this file.
#
#
#   -- do not edit anything above this line --   </std-header>

#------------------------------------------------------------
# If the flag is included in the param list, return its value
# Otherwise throw error
#
# Must catch the error
#-------------------------------------------------------------
proc tixGetArg {pkg_name flag default args} {
    global argv

    set args [concat $args $argv]
    set len [llength $args]
    set i 0

    while {$i < $len} {
	set arg [lindex $args $i]
	if {$flag == $arg} {
	    set params {}
	    incr i
	    while {$i < $len} {
		set param [lindex $args $i]
		if {[string index $param 0] != "-"} {
		    lappend params $param
		} else {
		    break
		}
		incr i
	    }
	    return $params
	}
	incr i
    }
    return $default
}

proc tixExistArg {pkg_name flag args} {
    global argv

    lappend args $argv

    if {[lsearch $flag $args] != "-1"} {
	return 1
    } else {
	return 0
    }
}

