# <std-header style=TCL orig-src=PTK>
#
#            Copyright 1998, NCR Corporation.  All Rights Reserved.
#
#                                NCR Confidential.
#
#
#  $Id: MDIWin.tcl,v 1.3 1998/05/19 03:22:47 kupsch Exp $
#
#  This file was originally part of ptk, a front end based on TCL/TK to the
#  Paradise database system developed by the University of Wisconsin-Madison.
#  The above copyright applies to changes made to this file by NCR Corporation.
#  The original copyright which may appear in the source below applies to the
#  original file as obtained by NCR Corporation and unchanged parts of this file.
#
#
#   -- do not edit anything above this line --   </std-header>

proc tixMDIWindow {w args} {
    eval tixInt_CreateWidget $w tixMdi TixMDIWindow $args
    return $w
}

proc tixMdi::CreateClassRec {} {
  global tixMdi

  # OPTIONS
  set tixMdi(rootOptions)   {}
  set tixMdi(options)       {
			     -clienttype
			     }
  set tixMdi(staticOptions) {-clienttype}

  # DEFAULT VALUES
  set tixMdi(-clienttype)   {-clienttype clientType ClientType tixMwmClient}

  # ALIASES


  # METHODS
  set tixMdi(methods)       {add place window}
}

proc tixMdi::InitWidgetRec {w class className args} {
    upvar #0 $w data
}

proc tixMdi::ConstructWidget {w} {
    upvar #0 $w data
} 

#----------------------------------------------------------------------
#                  Configuration commands
#----------------------------------------------------------------------

#----------------------------------------------------------------------
#                  public methods
#----------------------------------------------------------------------
proc tixMdi::add {w name args} {
    upvar #0 $w data

    return [eval $data(-clienttype) $w.$name $args]
}

proc tixMdi::place {w name args} {
    upvar #0 $w data

    return [eval place $w.$name $args]
}

proc tixMdi::window {w name args} {
    upvar #0 $w data

    if {$args == {}} {
	return $w.$name
    } else {
	return [eval $w.$name $args]
    }
}

