# <std-header style=TCL orig-src=PTK>
#
#            Copyright 1998, NCR Corporation.  All Rights Reserved.
#
#                                NCR Confidential.
#
#
#  $Id: polydemo.tcl,v 1.4 1998/05/19 03:22:29 kupsch Exp $
#
#  This file was originally part of ptk, a front end based on TCL/TK to the
#  Paradise database system developed by the University of Wisconsin-Madison.
#  The above copyright applies to changes made to this file by NCR Corporation.
#  The original copyright which may appear in the source below applies to the
#  original file as obtained by NCR Corporation and unchanged parts of this file.
#
#
#   -- do not edit anything above this line --   </std-header>

# The polygon data is loaded from geo land data in Long/Lat projection.
# The coordinates are assumed to be in range of -20 ~ 40 for x and
# 10 ~ 70 for y.
#
# The idea behind this:  Assume that we have a polygon repository
# which contains all the polygons to be displayed, we use get_next_polygon
# to retrieve polygons out of this repository one at a time and
# display them on screen one at a time.  The polygon repository will
# know the screen size in terms of pixels and will do necessary coordinates
# conversion in order to fit all polygons on screen.  The polygon passed
# back from repository to Tcl should be coordinates in pixels that
# directly displayed on screen by Tk.
#

proc poly_demo {c fname {color black}} {
	global view_w view_h;

	# screen size in pixels
	set x_span $view_w;
	set y_span $view_h;

	# use the current global bounding box
	global bx1 by1 bx2 by2;

	PDpoly_init $fname $x_span $y_span $bx1 $by1 $bx2 $by2;
	# experiments show that putting an update here will be very effective
	update;
	set pg [PDpoly_get_next_pg];
	while {$pg != "END"} {
		eval $c create polygon $pg -fill $color;
		set pg [PDpoly_get_next_pg];
	}

	PDpoly_done;
}

proc pline_demo {c fname {color black} } {
	# screen size in pixels
	set x_span 780;
	set y_span 780;

	# use the current global bounding box
	global bx1 by1 bx2 by2;

	PDpline_init $fname $x_span $y_span $bx1 $by1 $bx2 $by2;
	update;
	set pline [PDpline_get_next];
	while {$pline != "END"} {
		eval $c create line $pline -fill $color;
		set pline [PDpline_get_next];
	}

	PDpline_done;
}

