# <std-header style=TCL orig-src=PTK>
#
#            Copyright 1998, NCR Corporation.  All Rights Reserved.
#
#                                NCR Confidential.
#
#
#  $Id: ptkBulkLoad.tcl,v 1.5 1998/05/19 03:22:29 kupsch Exp $
#
#  This file was originally part of ptk, a front end based on TCL/TK to the
#  Paradise database system developed by the University of Wisconsin-Madison.
#  The above copyright applies to changes made to this file by NCR Corporation.
#  The original copyright which may appear in the source below applies to the
#  original file as obtained by NCR Corporation and unchanged parts of this file.
#
#
#   -- do not edit anything above this line --   </std-header>

# This file contains the tk script to bulk load a table
# It invokes FSBox to let user select the files to load into
# the table.
#
# ChangeLog
# =========
# Feb. 3, 1994:	Missed quote on each file to be loaded.
#		Use "append" to concat the file name list instead of
#		using "lappend".  The latter will cause "{" and "}"
#		to be added for proper list structure.

proc ptkBulkLoad tableName {
	global debugMode
	set fileList [FSBox errMsg]
	if {$fileList == "fsBoxError"} {
		tk_dialog .fsBoxError {Fatal Error} \
			{ File selection error: $errMsg} \
			error 0 OK
		return
	}
	if {$fileList == ""} { return }
	set nfl {}
	foreach fn $fileList {
		append nfl "\"$fn\","
	}
	set nfl [string trimright $nfl ","]
	set q "load table $tableName from $nfl"
	if {$debugMode == 1} { puts "Run query: <$q>" }

	ptkPDWait ON
	PDsql_cursorrun $q;
	ptkPDWait OFF
}

