# <std-header style=TCL orig-src=PTK>
#
#            Copyright 1998, NCR Corporation.  All Rights Reserved.
#
#                                NCR Confidential.
#
#
#  $Id: ptkVideo.tcl,v 1.10 1998/05/19 03:22:30 kupsch Exp $
#
#  This file was originally part of ptk, a front end based on TCL/TK to the
#  Paradise database system developed by the University of Wisconsin-Madison.
#  The above copyright applies to changes made to this file by NCR Corporation.
#  The original copyright which may appear in the source below applies to the
#  original file as obtained by NCR Corporation and unchanged parts of this file.
#
#
#   -- do not edit anything above this line --   </std-header>

# Try at your own risk.
#
# Jun Luo
# junluo@cs.wisc.edu
# 04/11/94
#

#
# Show a video object (defined by oid) resides in $tmpfn
#
set cntr 0

proc ptk_showvid {tmpfn oid indx} {
	global cntr bitmap_dir ParserOidAttributeName
				# ParserOidAttributeName added
				# by Navin Kabra: 7/1/96

	set bmp_dir "$bitmap_dir"
	set w .vid
	set cntr 0
	catch {destroy .vid}
	toplevel $w
	wm title $w "tk mpeg play"
	frame $w.scr -bd 5 -relief ridge -background black 

	set q "select * from $tmpfn where $ParserOidAttributeName = \"$oid\""
				# changed from oid = ... to 
				# $ParserOidAttributeName = ... by
				# Navin Kabra: 7/1/96
	# set fd [PDsql_open $q]
	set vid_list [PDcreate_video $q $w.scr.v $indx -v -dither ordered2 \
			-counter cntr]

	# now we only display the first video in the list
	set vidw [lindex $vid_list 0]

	# start a transaction for video retrieval
	# SMbeginxct

	frame $w.ctrl
	button $w.ctrl.pause -bitmap "$bmp_dir/tape_pause.xbm"  \
		-command "vid_pause $vidw"
	button $w.ctrl.play -bitmap "$bmp_dir/tape_play.xbm" \
		-command "$vidw play"
	button $w.ctrl.slowf -bitmap "$bmp_dir/tape_fwd_step.xbm" \
		-command "$vidw next"
	button $w.ctrl.ff -bitmap "$bmp_dir/tape_forward.xbm" \
		-command "$vidw ffwd"
	button $w.ctrl.rev -bitmap "$bmp_dir/tape_rewind.xbm" \
		-command "$vidw rev"
	button $w.ctrl.eject -bitmap "$bmp_dir/tape_eject.xbm"\
		-command "destroy $w"
	label $w.ctrl.lcd -textvariable cntr -width 6 -bd 3 \
		-relief sunken -anchor w -foreground green \
		-background black

	pack $w.scr $w.ctrl -side top -pady 1m -expand 1 -fill x
	pack $vidw
	pack $w.ctrl.pause $w.ctrl.play $w.ctrl.slowf $w.ctrl.ff $w.ctrl.rev \
		$w.ctrl.lcd $w.ctrl.eject -side left -padx 1 -pady 3 \
		-expand 1 -fill x
	update idletasks

	# set grab
	set old_grab [grab current]
	grab set $w
	tkwait window $w
	if {$old_grab != ""} {
		grab release $w
		grab set $old_grab
	}

	# remember to commit transaction
	# SMcommitxct
	# PDsql_close $fd
}

proc vid_pause {vidw} {
	global cntr
	set cntr [$vidw pause]
}

