# <std-header style=TCL orig-src=PTK>
#
#            Copyright 1998, NCR Corporation.  All Rights Reserved.
#
#                                NCR Confidential.
#
#
#  $Id: statBox.tcl,v 1.7 1998/05/19 03:22:34 kupsch Exp $
#
#  This file was originally part of ptk, a front end based on TCL/TK to the
#  Paradise database system developed by the University of Wisconsin-Madison.
#  The above copyright applies to changes made to this file by NCR Corporation.
#  The original copyright which may appear in the source below applies to the
#  original file as obtained by NCR Corporation and unchanged parts of this file.
#
#
#   -- do not edit anything above this line --   </std-header>

# ChangeLog
# =========
# feb 13, 1994:	Initial Version
#
# This file implements a status box.
#

# ------------------------------------------------------------
# <ptkPDStatBox> is the entry/exit point for status box, which
# will always be named ".ptkPDStatBox".
#
# [Arguments]
#	-ctrlCmd	Control command {ON OFF}
#
proc ptkPDStatBox ctrlCmd {
	set w ".ptkPDStatBox"
	catch "destroy $w"

	if {$ctrlCmd == "ON"} {
		toplevel $w
		wm geometry $w +360+360
		$w configure -bg SteelBlue -cursor watch
		message $w.msg -width 3i -bg SteelBlue -fg white \
			-text "                   \n\n\n"
		pack $w.msg -padx 0.5i -pady 0.5i
	}
}

# ------------------------------------------------------------
# <ptkPDStatBox::setMsg> is used to put message in status box.
# If the status box does not exist, or the message to be shown
# is empty string , it will do nothing and return.
#
# [Arguments]
#	-msg		The contents of msg.
#
proc ptkPDStatBox::setMsg msg {
	set w ".ptkPDStatBox"
	if {$msg == {}} {return}
	if {[winfo exists "$w"] == 0} { return }

	# if we are still here, we can not put up the message
	wm title $w "Running..."
	$w.msg configure -text "$msg"
	pack $w.msg
	update
}

