////////////////////////////////////////////////////////////////////////////////////////////////////
//
//  baddTranslator.h
//
//  Defines that baddTranslator class.  This class is used to translate profiles that users
//  enter as standard SQL statements into the series of queries that are executed to 
//  run a profile.  This series of queries somputes what to disseminat based on the timestamp
//  of each tuple, and the timestamp of the profile.
//
//  Bruce Jackson
//  Professor David DeWitt
//
//  Jan 1999
//
////////////////////////////////////////////////////////////////////////////////////////////////////


#ifndef BADD_TRANSLATOR_H
#define BADD_TRANSLATOR_H

/* General Includes */
#include <iostream.h>
#include <strstream.h>
#include <assert.h>
#include "where_scanner.h"
#include "badd_error.h"
#include "all_global.h"


/* Includes for Navin Parser */
#include <fstream.h>
#include <math.h>
#include <Acat.h>
#include <Aglob_vars.h>
#include <Bparsetree.h>
#include <stdlib.h>
#include <iomanip.h>
#include <stdio.h> 
#include <sys/time.h> 

//----------------------------------------------------------------------------------------
// global variables pointing to the scanner input buffer, scanInput is manipulated
// and inbuf is not.  inbuf is buffer data is read into prior to scanning
//---------------------------------------------------------------------------------------------------
extern WHEREYYSTYPE  whereyylval; 
extern char inbuf[2048];
extern char* scanInput;
extern int scanInputLimit;

class baddTranslator{
    public:
         baddTranslator( int _profileId, int _clientId , char* query ); 
	 ~baddTranslator();
	 char * translateQuery(int &status, int &numTemp);	

  private:
	 char * constructQuery(int    numBase, 
			       char**  names, 
			       char**  idents, 
			       char*   originalWhere);
	 bool   parseQuery(char* inQuery);
	 bool   typecheckQuery(char* inQuery);
	 
	 int    clientId;
	 int    profileId;
	 char * dbname;
};

#endif











