
#include <badd_error.h>

//----------------------------------------------------------------------------------------
//  constructor() - assigns strings the array of error messages
//
//  ARGS:    none
//  RETURN:  none
//----------------------------------------------------------------------------------------
baddErrorManager::baddErrorManager(){
   
      _err_msgs[OK]=                   "\t*err*: OK";
      _err_msgs[FAIL]=                 "\t*err*: General Failure";
      _err_msgs[DONE]=                 "\t*err*: Task completed";
      _err_msgs[CURSOR_ERROR]=         "\t*err*: Cursor call error";
      _err_msgs[DB_OPEN_ERROR]=        "\t*err*: Failed to open db";
      _err_msgs[DB_CLOSE_ERROR]=       "\t*err*: Failed to close db";
      _err_msgs[NO_RESULT]=            "\t*err*: No result tuples" ;
      _err_msgs[PARSE_FAILED]=         "\t*err*: Parsing client query failed" ;
      _err_msgs[TYPECHECK_FAILED]=     "\t*err*: Typechecking query failed" ;
      _err_msgs[TRANSLATION_FAILED]=   "\t*err*: Query translation failed" ;
      _err_msgs[UPDATE_FAILED]=        "\t*err*: Failed to update profile" ;
      _err_msgs[ADD_FAILED]=           "\t*err*: Failed to add the new profile" ;
      _err_msgs[PROFILE_EXISTS]=       "\t*err*: Attempted to add a profile that exists" ;
      _err_msgs[NO_SUCH_PROFILE]=      "\t*err*: Attempted to delete a profile that does not exist" ;
      _err_msgs[DELETE_FAILED]=        "\t*err*: Failed to delete a profile" ;
      _err_msgs[SEND_PROFILE_FAILED]=  "\t*err*: Failed to send profile result to client" ;
      _err_msgs[TAR_ERROR]=            "\t*err*: tar system call failed";
      _err_msgs[FAILED_TO_CONNECT]=    "\t*err*: failed to create a TCP connection";
      _err_msgs[EXISTS]=               "\t*err*: table exists";
      _err_msgs[NOT_EXISTS]=           "\t*err*: table does not exist";
      _err_msgs[COMMIT_FAILED]=        "\t*err*: failed to commit transaction";
      _err_msgs[FILE_OPEN_FAILED]=     "\t*err*: failed to open specified file";
}

//----------------------------------------------------------------------------------------
//  destructor() - 
//
//  ARGS:    none
//  RETURN:  none
//----------------------------------------------------------------------------------------
baddErrorManager::~baddErrorManager()
{ }


//----------------------------------------------------------------------------------------
//  display() - displays the error message corresponding to the error code argument
//
//  ARGS:    errorCode - the error code
//  RETURN:  none
//----------------------------------------------------------------------------------------
void baddErrorManager::display(short errorCode)
{
     if(errorCode < 0 || errorCode >=NUM_ERRORS)
       cout << "Invalid BADD error manager code: "<< errorCode << endl;
     else
       cout << _err_msgs[errorCode]<<": ("<<errorCode<<")"<<endl;;
}







