////////////////////////////////////////////////////////////////////////////////////////////////////
//
//  baddErrorManager.h
//
//  This class is used to manage error codes and messages.  The enumeration baddStatus
//  defines the error codes.
//
//  Bruce Jackson
//  Professor David DeWitt
//
//  Jan 1999
//
////////////////////////////////////////////////////////////////////////////////////////////////////

#ifndef BADD_ERROR_MANAGER
#define BADD_ERROR_MANAGER

#include <stringType.h>  //paradise string type
#include <iostream.h>

/* BADD error codes */
enum baddStatus {
      OK,                  /* OK */
      CURSOR_ERROR,        /* Cursor call error */
      DB_OPEN_ERROR,       /* Error opening a DB */
      DB_CLOSE_ERROR,      /* Error closing a DB */
      FAIL,                /* For general unclassified errors */
      DONE,                /* Used to indicate a task is completed */
      NO_RESULT,           /* Profile execution produced no result tuples */
      PARSE_FAILED,        /* Parse error */
      TYPECHECK_FAILED,    /* Typechecking error */
      TRANSLATION_FAILED,  /* Translation error */
      UPDATE_FAILED,       /* Failed to update a profile */
      ADD_FAILED,          /* Failed to add a profile */
      PROFILE_EXISTS,      /* Attempted to add an existing profile */
      DELETE_FAILED,       /* Failed to delete a profile */
      NO_SUCH_PROFILE,     /* Attempted deleting a non-existent profile */
      SEND_PROFILE_FAILED, /* Failed to send profile to client */
      TAR_ERROR,           /* TAR system call failed */
      FAILED_TO_CONNECT,   /* Failed to make a TCP connection */
      EXISTS,              /* table exists */
      NOT_EXISTS,          /* table does not exist */
      COMMIT_FAILED,       /* transaction commit failed */
      FILE_OPEN_FAILED,    /* failed to open file */
      
      NUM_ERRORS           /* the MAX number of errors */
};


class baddErrorManager{

    public: 
         baddErrorManager();
	 ~baddErrorManager();
	 void display(short errorCode);
    private:
         String _err_msgs[NUM_ERRORS];
};

#endif









