////////////////////////////////////////////////////////////////////////////////////////////////////
//
//  ids_receiver.cpp  -  definition of the ids receiver thread object.  This thread receives
//                       profile management requests from smartPull clients 
//
//  Bruce Jackson
//  Professor David DeWitt
//
//  Jan 1999
//
////////////////////////////////////////////////////////////////////////////////////////////////////


#ifndef IDS_RECEIVERT_H
#define IDS_RECEIVERT_H

/* General Includes */
#include <pthread.h>
#include <all_global.h>
#include <thread.h>
#include <iostream.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <string.h>
#include <stdlib.h>
#include <errno.h>
#include <time.h>
#include <signal.h>

#include "push_global.h"
#include "sql_stuff.h"
#include "tcpSock.h"
#include "mutex_multimap.h"
#include "pm_message.h"


class idsReceiver : public P_Thread {
 public:
	idsReceiver();
	virtual ~idsReceiver();
	virtual int run();
 private:
	int       processMessage();
	int       addProfile(AProfile ap);
	int       deleteProfile(int pid, int cid);
	int       updateClientParameters( char* sqlstring );
	void      sendError(TCPSock* sock, int errorcode);

	int       showClientParameters(int cid, int pid, char* sqlstring );

	TCPSock*   _socket;
	TCPSock*   _sendersSocket;
	SQLQuery*  _query;
};

#endif










