////////////////////////////////////////////////////////////////////////////////////////////////////
//
//   ids_updater_thread.h  
//
//   Definition of the ids_updater_thread used by smartPull.  This
//   thread is responsible for sending profile add and delete requests,
//   and parameter update requests to the IDS site.  It sends these requests
//   based on the "state" of the local profile.
//
//   Bruce Jackson
//   Professor David DeWitt
//
//   Jan 1999
//
////////////////////////////////////////////////////////////////////////////////////////////////////

#ifndef _UPDATER_THREAD_H
#define _UPDATER_THREAD_H

/* General Includes */
#include <pthread.h>
#include <iostream.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <string.h>
#include <stdlib.h>
#include <errno.h>
#include <time.h>
#include <signal.h>

/* BADD Includes */
#include "all_global.h"
#include "pull_global.h"
#include "sql_stuff.h"
#include "tcpSock.h"
#include "pull_global.h"
#include "all_global.h"
#include "thread.h"
#include "pm_message.h"

#define PROFILE_UPDATE_TIME  10

class updaterThread : public P_Thread 
{
   public:
	updaterThread();
	virtual ~updaterThread();
	virtual int run();

   private:
	void      updateProfiles();
	void      updateParameters();

	int       sendProfileAddMessage( AProfile ap );
	int       sendProfileDeleteMessage( int pid, int cid );	

	ParaCursor *   cursor;
	ParaConnect *  connection;
	TCPSock *      ids_sock;
};

#endif










