

#include "pm_message.h"
#include "tcpSock.h"
#include <fstream.h>
#include <pthread.h>

#define DEBUG

int RECEIVE_PORT = 10004;

void run_fnc(void* ptr);

int main(int argc, char ** argv)
{

    RECEIVE_PORT = atoi(argv[1]); 

    const char * sql1 = "select * from profiles where prof_state = 3 AND this will be a test of a really long SQL stmt like those found in the profiles that must be run for a badd profile to be executed and then we will talk some more and then this stmt will become very long and I don't really know what more to say at this point";
    const char * sql2 = "update profiles set TS = 0";
    const char * sql3 = "delete from profiles where pf = 6";
    const char * addr = "flamingo.wisc.edu";
    pthread_t pt;
    bool st;
    
    // listening thread
    if( (pthread_create( &pt, NULL, (void *)&run_fnc, NULL)) != 0){
	cerr << "thread creation failed"<<endl;
	exit(1);
    }	

    TCPSock * sock_out = new TCPSock("flamingo.cs.wisc.edu", RECEIVE_PORT, st);
    if(!st){
	cerr << "Socket connection failed"<<endl;
	exit(1);
    }

    

    // output file
    ofstream out("testfile.ttt", ios::app);
    if(!out){
	cerr << "file open failed"<<endl;
	exit(1);
    }    
    
    // and add pm_message
    pm_message *  m = new pm_message( ADD_MESSAGE_TYPE, 
				      100, 
				      1, 
				      6100, 
				      45, 
				      3, 
				      strlen(addr)+1, 
				      strlen(sql1)+1, 
				      addr, 
				      sql1);
    
    // a delete profile request
    pm_message *  m2 = new pm_message( DELETE_MESSAGE_TYPE, 
				 200, 
				 1); 
    
    // an update parameter request
    pm_message *  m3 = new pm_message( UPDATE_MESSAGE_TYPE, 
				 200, 
				 1,
				 strlen(sql2)+1,
				 sql2);
    
    
    cout << m  << endl;
    cout << m2 << endl;
    cout << m3 << endl;
    
    char * sendBuf = new char[512];
    int ret, len, bytesSent=0;

    len = m->getMsgLength();
    m->getBytes( sendBuf );
    sock_out->put(len);
    bytesSent = sock_out->put_bytes( (void*)sendBuf, len );
    assert( bytesSent == len );
    sock_out->get( ret );
    cout << "Sent pm_message 1 of length "<< bytesSent << ", got back ret="<<ret<<endl;
    sock_out->close();


    sock_out = new TCPSock("flamingo.cs.wisc.edu", RECEIVE_PORT, st);
    if(!st){
	cerr << "Socket connection failed"<<endl;
	exit(1);
    }
    len = m2->getMsgLength();
    m2->getBytes( sendBuf );
    sock_out->put(len);
    bytesSent = sock_out->put_bytes( sendBuf, len );
    assert( bytesSent == len );
    sock_out->get( ret );
    cout << "Sent pm_message 2 of length "<<bytesSent<< ", got back ret="<<ret<<endl;
    sock_out->close();

    sock_out = new TCPSock("flamingo.cs.wisc.edu", RECEIVE_PORT, st);
    if(!st){
	cerr << "Socket connection failed"<<endl;
	exit(1);
    }
    len = m3->getMsgLength();
    m3->getBytes( sendBuf );
    sock_out->put(len);
    bytesSent = sock_out->put_bytes( sendBuf, len );
    assert( bytesSent == len );
    sock_out->get( ret );
    cout << "Sent pm_message 3 of length "<< bytesSent << ", got back ret="<<ret<<endl;
    sock_out->close();

    delete[] sendBuf;
    delete sock_out;
    out.close();
    delete m, m2, m3;
    return 0;
}



void 
run_fnc(void * ptr)
{
    
    bool       st;
    TCPSock *  sender_sock;
    int        msgLength=0, msgNum = 0;
    pm_message *  m;
    char *     buf = new char[512]; 

    TCPSock * sock = new TCPSock(RECEIVE_PORT, st);
    if(!st){
	cerr << "Socket creation failed"<<endl;
	exit(1);
    } 

    ofstream rout( "reciever.out", ios::app );
    if(!rout){
	cerr << "receiver log open failed"<<endl;
	exit(1);
    }


    for(;;) {

	bzero(buf, 512);
	
	//--------------------------------------------------
	//  Wait for the next profile management request
	//--------------------------------------------------
	sender_sock = sock->accept();
	
	//----------------------------------------
	//  Got One
	//----------------------------------------
	sender_sock->get( msgLength );
	sender_sock->get_bytes( buf, msgLength );
	cout << "Message of length "<< msgLength << " received:" << endl;

	m = new pm_message ( buf, msgLength );
	assert ( m->getMsgLength() == msgLength );
	time_t my_time = time(NULL);
	rout << "//////////////////////////////////////////////////////////////////////////////////////////\n";
	rout << "//  " << endl;
	rout << "//  Profile Management Prequest Received at: "<< ctime(&my_time);
	rout << "//  " << endl;
	rout << "//////////////////////////////////////////////////////////////////////////////////////////\n";
	rout << endl << endl;
	rout << m;
	rout << endl;
	rout << endl<<endl;
	sender_sock->put( (++msgNum) );
	sender_sock->close();	
    }
}






