
#ifndef _MESSAGE_H
#define _MESSAGE_H

#include <arpa/inet.h>
//#include <sys/debug.h>
#include <iostream.h>
#include <assert.h>
#include <netinet/in.h>
#include <sys/types.h>
#include <stdio.h>
#include <strings.h>
#include <unistd.h>


#define DEL_MSG_SIZE      (     4     /* msgType   */            \
                              + 4     /* cid       */            \
                              + 4     /* pid       */            \
                              + 4     /* length    */            \
                           )                                     \


#define MIN_ADD_MSG_SIZE  (     4     /* msgType   */            \
                              + 4     /* cid       */            \
                              + 4     /* pid       */            \
                              + 4     /* length    */            \
                              + 4     /* port      */            \
                              + 4     /* period    */            \
                              + 4     /* setNumBase*/            \
                              + 4     /* addrLen   */            \
                              + 4     /* sqlLen    */            \
                           )                                     \


#define MIN_UPDATE_MSG_SIZE (   4     /* msgType   */            \
                              + 4     /* cid       */            \
                              + 4     /* pid       */            \
                              + 4     /* length    */            \
                              + 4     /* sqllen    */            \
                            )                                    \


enum msgTypes {
     ADD_MESSAGE_TYPE,
     DELETE_MESSAGE_TYPE,
     UPDATE_MESSAGE_TYPE
};


class pm_message{
    
 public:

     // Create a generic pm_message
     pm_message( int length );
     
     // Create a pm_message from a received buffer
     pm_message( const char * mes, int length );

     // Create an ADD_MESSAGE
     pm_message( msgTypes msgType, int cid, int pid, int port, 
	      int period, int numBase, int addlen, int sqllen, 
	      const char * addrstring, const char * sqlstring);
     
     // Create an UPDATE_MESSAGE
     pm_message( msgTypes msgType, int cid, int pid, 
	      int sqllen, const char * sqlstring);
     
     // Create a DELETE_MESSAGE
     pm_message( msgTypes msgType, int cid, int pid );

     ~pm_message( );
     
     friend   ostream& operator<<(ostream& outs, pm_message * m);    
     void     dump();

     void     setMsgType( int msgType );
     void     setCID( int cid );
     void     setPID( int pid );
     void     setMsgLength( int len );
     void     setPort( int port );
     void     setPeriod( int period );
     void     setNumBase( int numBase );
     void     setSQLLength( int length );
     void     setAddrLength( int length );
     void     setSQL( const char * port );
     void     setAddr( const char * addr );
     
     int      getMsgType( );
     int      getCID( );
     int      getPID( );
     int      getMsgLength( );
     int      getPort( );
     int      getPeriod( );
     int      getNumBase( );
     int      getAddrLength( );
     int      getSQLLength( );
     char *   getAddr( );
     char *   getSQL( );
     void     getBytes( char* &buf );
     
 private:
     char *   data;    
};


#endif _MESSAGE_H






