////////////////////////////////////////////////////////////////////////////////////////////////////
//
//  pull_global.h 
//
//  Contains the definitions of variables and functions global to smartPull  
//
//  Bruce Jackson
//  Professor David DeWitt
//
//  Jan 1999
//
////////////////////////////////////////////////////////////////////////////////////////////////////


#ifndef PULL_GLOBAL_H
#define PULL_GLOBAL_H

/* General Includes */
#include <iostream.h>
#include <strstream.h>
#include <all_global.h>
#include <badd_error.h>
#include <Aglob_vars.h>
#include <cplusplusApi.h>
#include <badd_error.h>
#include <where_scanner.h>


// Profile States
enum profileStates{
  REGISTERED,           /* 0   This profile has been registered at IDS and is running */
  ADD_PROFILE,          /* 1   This profile needs to be registered at the IDS site    */
  DELETE_PROFILE,       /* 2   This profile should be deleted at the IDS site         */
  DELETED_AT_IDS,       /* 3   This profile has been deleted at the IDS site          */
  UPDATE_PARAM,         /* 4   Update parameters message type code                    */ 
  MAX_PROFILE_STATES    /* 5   MAX state - used for assertions                        */
};


extern int PARADISE_PORT;                /* paradise server port                                  */
extern int IDS_RECEIVER_PORT ;           /* IDS port that listens for profile updates             */
extern int PULL_RECEIVER_PORT ;          /* MY port that listens for profile updates              */
extern const char* CLIENT_DB_NAME;       /* The Client db name                                    */
extern int CLIENT_ID;                    /* The ID of the client running this pull receiver       */
extern const char* PULL_RECEIVER_LOG;    /* Name of file where receiver thread logs transactions  */
extern const char* PULL_RECEIVER_LOG;    /* MY Receiver port number is written to this file       */  
extern const char* IDS_REC_PORT_FILE;    /* the IDS receiver port                                 */
extern char* IDS_HOSTNAME;               /* the host running the Smart Push server                */
extern char* PULL_REC_PORT_FILE;         /* MY Receiver port number is written to this file       */  
//extern char* IDS_DB_NAME;                /* The IDS db name                                       */
extern char* PULL_REC_PORT_FILE;         /* MY Receiver port number is written to this file       */  

#endif






