////////////////////////////////////////////////////////////////////////////////////////////////////
//
//  pull_receiver.h
//
//  This thread listens on a specified port for profile management requests from the 
//  clients CGI web based profile management client.  This client sends requests to
//  this thread, and the requests are processed by this thread.
//
//  Bruce Jackson
//  Professor David DeWitt
//
//  Jan 1999
//
////////////////////////////////////////////////////////////////////////////////////////////////////


#ifndef PULL_RECEIVERT_H
#define PULL_RECEIVERT_H

#include <pthread.h>
#include <iostream.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <string.h>
#include <stdlib.h>
#include <errno.h>
#include <time.h>
#include <signal.h>

#include "thread.h"
#include "baddTranslator.h"
#include "pull_global.h"
#include "all_global.h"
#include "sql_stuff.h"
#include "tcpSock.h"


class pullReceiver : public P_Thread {

     public:

        // Public methods 
        //
	pullReceiver();
	virtual ~pullReceiver();
	virtual int run();
     private:

	//  Private functions
	//
	int       process_msg();
	int       addProfile( AProfile ap, char* queryString);
	int       deleteProfile( int pid, int cid);
	int       updateClientParameters(int pid, char* sqlstring );
	int       showClientParameters(int cid, int pid, char* sqlstring );
	void      sendError(TCPSock* sock, int errorcode);

	// Private data members
	//
	pthread_t  idsProfileUpdater;          // A thread that updates profiles with the IDS
	TCPSock*   _socket;                    // Our data receiver socket
	TCPSock*   _sendersSocket;             // The data sender socket (IDS)
	SQLQuery*  _query;                     // An SQL query object
	int	   _clientId;                  // My ID
	int	   _profileId;                 // The ID for the current profile we receive data
};

#endif










