/*******************************************************************************
 * 
 *   Queue.h - Queue
 * 
 ******************************************************************************/

#ifndef _QUEUE_H_
#define _QUEUE_H_

////////////////////////////////////////////////////////////////////////////////
// Include files
////////////////////////////////////////////////////////////////////////////////
#include <deque.h>
#include <pthread.h>
#include <assert.h>

// Forward class declaration
class profileThread;

typedef profileThread* dataType;

////////////////////////////////////////////////////////////////////////////////
//
// class definition
//
////////////////////////////////////////////////////////////////////////////////

class queueObj {

    public:
    	// ....................
    	// Functions
    	// ....................
    	queueObj( );
    	~queueObj( );
      	void Put( dataType element );  
    	void Get( dataType & element );
	int  Size( );
	void Lock( );
	void Unlock( );
	void Dump( );

    private:
    	// ....................
        // Data members
    	// ....................
   	deque<dataType> 	       q;     // The queue
	pthread_mutex_t	*         qMutex;
};

#endif _QUEUE_H_



