////////////////////////////////////////////////////////////////////////////////////////////////////
//
//  readWriteLock.h 
//
//  A read-write lock using a mutex and a condition variable
//
//  Bruce Jackson
//  Professor David DeWitt
//
//  Jan 1999
//
////////////////////////////////////////////////////////////////////////////////////////////////////

#ifndef READ_WRITE_LOCK_H
#define READ_WRITE_LOCK_H

#include <pthread.h>
#include <iostream.h>

class readWriteLock {
  public:
        readWriteLock( int numreaders=0, int numwriters=0 ); 
        ~readWriteLock();
	
	void  readerLock();
	void  writerLock();
	int   readerUnlock();
	int   writerUnlock();

  private:
        int              readersReading;
        int              writersWriting;
        pthread_mutex_t  rw_mutex;
        pthread_cond_t   lock_free;
};

#endif





