////////////////////////////////////////////////////////////////////////////////////////////////////
//
//  smartPull.h
//
//  This is the definition of the smartPull receiver class.  smartPull listens
//  for incoming messages from the IDS.  When a message arrives, smartPull gets
//  the message, untarrs the message, and executes the SQL statements comtained
//  in the schema file sent with the data.  These statements will create the 
//  tables on the client side if need be, and then load tose tables with the data 
//  that just arrived.  After executing these SQL statements, smartPull listens
//  for the next message to arrive.  
//
//  Bruce Jackson
//  Professor David DeWitt
//
//  Jan 1999
//
////////////////////////////////////////////////////////////////////////////////////////////////////

#ifndef SMARTPULL_H
#define SMARTPULL_H

#include <pthread.h>
#include <fstream.h>
#include <cplusplusApi.h>

#include "pull_global.h"
#include "all_global.h"
#include "sql_stuff.h"
#include "pull_receiver.h"
#include "ids_updater_thread.h"

class smartPull {

public:
  
        // Public methods
        //
	smartPull(int port);
	~smartPull();
	void run();

private:
	
	// Private data
	//
	int         _dataport;            // DATA port
	TCPSock *   _socket;              // my socket
	TCPSock     _pushSocket;          // the socket for the smartPush server
	int         _myid;                // this clients id
	int         _profileid;

	// Private methods
	//
	pthread_t   idsProfileUpdater;
        void *      updateIDSProfiles( void* puArgs );
        int         do_select(timeval timer);
	int         get_msg();
	int         process_msg();
	void        set_timer(timeval&);
};

#endif









