////////////////////////////////////////////////////////////////////////////////////////////////////
//
//  tcpSock.h
//
//  A wrapper class for TCP sockets.  Created by Sowmya Subramanian, modified by B. Jackson
//
//  Bruce Jackson:  from Sowmya Subramanian
//  Professor David DeWitt, BADD-project
//
//  Jan 1999
//
////////////////////////////////////////////////////////////////////////////////////////////////////


#ifndef TCPSOCK_H
#define TCPSOCK_H


/* General Includes */
#include <stdio.h>
#include <stdlib.h>
#include <iostream.h>
#include <fstream.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <sys/stat.h>
#include <sys/utsname.h>
#include <strings.h>
#include <unistd.h>
#include <netdb.h>



class TCPSock {
  public:
	TCPSock();
	TCPSock( int port, bool& con_stat);                           /* listen on port */
	TCPSock( char * host, int port, bool& con_stat);         /* connect to host/port */
	virtual ~TCPSock();                           
	
	int assign();
	int bind(int = 0);
	int connect(const char *host, int port);
	int close();

	int listen();
	inline int listen(int port) { 
		int status;
		if(bind(port) == false) return false; 
		status = listen();
		return status;
	}
	
	TCPSock *accept();
	int accept(TCPSock &);
	int accept(TCPSock *);

	int get_port();
	int get_socket() {return _sockfd;}
	
	virtual int get_bytes(void*, int);
	virtual int put_bytes(const void*, int);
	virtual int get(int &i);
	virtual int put(int i);
private:
	 int _sockfd;
	 int do_connect(const char *,int);
};


#endif








