////////////////////////////////////////////////////////////////////////////////////////////////////
//
//  thread.h
//
//  Created by Sowmya Subramanian, modified by B. Jackson
//
//  Gives a generic wrapper class for pthreads. In order to use it, derive a subclass of this
//  and define the run() method.
//
//  Bruce Jackson
//  Professor David DeWitt
//
//  Jan 1999
//
////////////////////////////////////////////////////////////////////////////////////////////////////

#ifndef _P_THREAD_H
#define _P_THREAD_H


/* General Includes */
#include <pthread.h>
#include <errno.h>
#include <stdlib.h>
#include <iostream.h>

class P_Thread {

public:
	P_Thread();
	virtual         ~P_Thread() { }
	int             start();	
	virtual int     run() = 0;	
	static void *   startFunction(void* arg);	
	pthread_t       get_tid() { return _tid; }
	int             end();
	int             detach();

protected:
	int             join(pthread_t targetid);
	pthread_t       _tid;
	pthread_attr_t  _attr;
};

#endif



