////////////////////////////////////////////////////////////////////////////////////////////////////
//
//  thread_cond.h
//
//  Created by Sowmya Subramanian, modified by B. Jackson
//
//  This file contains the definition of the P_Cond class, which is a generic 
//  class used to define pthread_cond variables.
//
//  Bruce Jackson
//  Professor David DeWitt
//
//  Jan 1999
//
////////////////////////////////////////////////////////////////////////////////////////////////////

#ifndef _THREAD_COND_H
#define _THREAD_COND_H

/* General Includes */
#include <pthread.h>
#include <iostream.h>
#include <stdio.h>

class P_Cond {
	
 public:
  P_Cond(){
    int status;
    status = pthread_condattr_init(&_attr);
    status = pthread_cond_init(&_cond, NULL);
  }
  
  ~P_Cond() {}
  
  int signal(){ 
    int status;
    if((status = pthread_cond_signal(&_cond))!=0)
      perror("Error signaling condition variable");
    return status;
  }
  
  int timedwait(pthread_mutex_t *mutex, const struct timespec *abstime) {
    
    int status;
    status = pthread_cond_timedwait(&_cond, mutex, abstime);
    return status;
  }
  
  
  void wait(pthread_mutex_t *mutex)
    {
      pthread_cond_wait(&_cond, mutex);
    }
  
 private:
  pthread_cond_t _cond;
  pthread_condattr_t _attr;
};

#endif
