/******************************************************************************
** thread_mutex.h
** Sowmya Subramanian
** 
** This file contains a generic mutex class definition. All the basic 
** operations have been encapsulated as methods. This is pthread specific.
******************************************************************************/
////////////////////////////////////////////////////////////////////////////////////////////////////
//
//  thread.h
//
//  Created by Sowmya Subramanian, modified by B. Jackson
//
//  This file contains a generic mutex class definition. All the basic 
//  operations have been encapsulated as methods. This is pthread specific.
//
//  Bruce Jackson
//  Professor David DeWitt
//
//  Jan 1999
//
////////////////////////////////////////////////////////////////////////////////////////////////////

#ifndef _THREAD_MUTEX_H
#define _THREAD_MUTEX_H

/* GENERAL Includes */
#include <pthread.h>
#include <stdio.h>


class P_Mutex {
 public:
       P_Mutex() {pthread_mutex_init(&_mutex, NULL);}
       ~P_Mutex() {}
	
       int lock(){
	 int status;
	 if((status = pthread_mutex_lock(&_mutex)) != 0)
	   perror("Error acquiring mutex lock");
	 return status;
       }
       
       int unlock(){
	 int status;
	 if((status = pthread_mutex_unlock(&_mutex)) != 0)
	   perror("Error unlocking mutex lock");
	 return status;
       }
       
       int trylock() { return pthread_mutex_trylock(&_mutex);}
       
       pthread_mutex_t& get_mutex() { return _mutex; }

private:
       pthread_mutex_t _mutex;
};

#endif










