%{
#include "where_scanner.h"
#include <iostream.h>
#include <string.h>

extern int my_yyinput(char *buf, int max_size);

#undef YY_INPUT
#define YY_INPUT(b,r,ms) (r = my_yyinput(b, ms))

static int	linenum = 1; /* maintain this as line number current
                                 token was scanned on */
static int	colnum = 1; /* maintain this as column number current
                                 token began at */
void curpos();
%}
Digit		[0-9]
Letter          [a-zA-Z]
Whitespace      [\t\n ]
Operators       [+-=<>!]

%%

        /* simply return the where clause from an sql string */

[Ww][Hh][Ee][Rr][Ee]{Whitespace}[^;]*   {/* where clause id stored in yytext  */ 
					   whereyylval.t.strval=whereyytext;
					   return WHERE_CLAUSE;
					 }
[^;]                                     { return PRE_WHERE_CLAUSE; }

. { /* nothing to do here */ }


%%
void curpos(){ /* store current token position */
	whereyylval.t.linenum = linenum;
	whereyylval.t.colnum = colnum;
}

int whereyywrap(){ return 1;}


extern char *scanInput;

int my_yyinput(char *buf, int max_size){

     int r = strlen(scanInput);
     if (r > max_size) r = max_size;
     strncpy (buf, scanInput, max_size);
     scanInput += r;
         //cout << "got: "<< r <<" bytes"<<endl;
         //cout << "max_size is: "<< max_size <<" bytes"<<endl;
     return r;
}


