#ifndef where_scanner_h_
#define where_scanner_h_

struct Token {
  int           linenum; /* Line number token appears on */
  short		colnum;  /* Column number token starts at */
  char*		strval;  /* Used for strings -- the where clause */
};

#include "where.tab.h"

/* yylex, generated by lex or flex,  reads a token from sourcefile and returns
   its token code as the value of the function.
   For single char tokens the code is the char itself; for all other the code
   is defined in y.tab.h.

   It sets the value of yylval.t.linenum and yylval.t.colnum.
   yylval.t.strval (for STRINGS).
*/

//extern FILE *whereyyin;  /* yyin should point to the file yylex is to scan from */

extern int whereyylex();
#define WHEREYYLVAL whereyylval    
#endif


